# -*- coding: utf-8 -*-

# Standard Library
from abc import abstractmethod, ABCMeta

# Vendor Library
from m3.actions.exceptions import ApplicationLogicException


class BaseIndex(object):
    """
    Базовый класс для показателей
    """

    __metaclass__ = ABCMeta

    def __init__(self, unit, session=None):

        self.unit = unit
        self.unit.unit_mo_id = self.unit_mo_id = unit.get_mo().id
        self.dou_type = unit.dou_type

        self.session = session

    @classmethod
    def get_algorithm(cls, index_type):

        try:
            clazz = cls.ALGORITHM_MAP[index_type]
        except KeyError:
            raise ApplicationLogicException(
                u'Такой показатель не реализован')

        return clazz

    @abstractmethod
    def get_count(self):
        pass
